/*
 * Copyright 2009
 *     PYRASIS.COM,.  All rights reserved.
 *
 * Author:
 *     Lee Jae-Hong (pyrasis)
 */

#include <ntddk.h>
#include "condvar.h"

KCONDITION_VARIABLE CondVar;
KMUTEX Mutex;

VOID
Thread1 (
    VOID
    )
{
    int i;
    LARGE_INTEGER delay;

    delay.LowPart = (ULONG)-10000000;
    delay.HighPart = -1;

    for (i = 0; i < 10; i++)
    {
        // ٸ 带  ϱ  ٸ   ߿ Ǿ Ѵ.
        KeDelayExecutionThread(KernelMode, FALSE, &delay);

        KeWaitForSingleObject(&Mutex, Executive, KernelMode, FALSE, NULL);
        //KeWakeConditionVariable(&CondVar);
        KeWakeAllConditionVariable(&CondVar);

        DbgPrint("Thread 1 : %d\n", i);

        KeReleaseMutex(&Mutex, FALSE);
    }
}


VOID
Thread2 (
    VOID
    )
{
    int i;
    LARGE_INTEGER delay;

    delay.LowPart = (ULONG)-07000000;
    delay.HighPart = -1;

    for (i = 0; i < 10; i++)
    {
        KeDelayExecutionThread(KernelMode, FALSE, &delay);

        KeWaitForSingleObject(&Mutex, Executive, KernelMode, FALSE, NULL);
        KeSleepConditionVariableMX(&CondVar, &Mutex, NULL);

        DbgPrint("Thread 2 : %d\n", i);

        KeReleaseMutex(&Mutex, FALSE);
    }
}


VOID
Thread3 (
    VOID
    )
{
    int i;
    LARGE_INTEGER delay;

    delay.LowPart = (ULONG)-07000000;
    delay.HighPart = -1;

    for (i = 0; i < 10; i++)
    {
        KeDelayExecutionThread(KernelMode, FALSE, &delay);

        KeWaitForSingleObject(&Mutex, Executive, KernelMode, FALSE, NULL);
        KeSleepConditionVariableMX(&CondVar, &Mutex, NULL);

        DbgPrint("Thread 3 : %d\n", i);

        KeReleaseMutex(&Mutex, FALSE);
    }
}

VOID
Unload (
    __in PDRIVER_OBJECT DriverObject
    )
{

}

NTSTATUS
DriverEntry (
    __in PDRIVER_OBJECT DriverObject,
    __in PUNICODE_STRING RegistryPath
    )
{
    NTSTATUS status;
    HANDLE threadHandle1, threadHandle2, threadHandle3;
    PDEVICE_OBJECT deviceObject = DriverObject->DeviceObject;

    DriverObject->DriverUnload = Unload;

    KeInitializeConditionVariable(&CondVar);
    KeInitializeMutex(&Mutex, 0);

    status = PsCreateSystemThread(
        &threadHandle1,
        (ACCESS_MASK) 0L,
        NULL,
        NULL,
        NULL,
        (PKSTART_ROUTINE)Thread1,
        deviceObject);

    if (!NT_SUCCESS(status))
    {
        DbgPrint("PsCreateSystemThread() 0x%x\n", status);

        return status;
    }

    status = PsCreateSystemThread(
        &threadHandle2,
        (ACCESS_MASK) 0L,
        NULL,
        NULL,
        NULL,
        (PKSTART_ROUTINE)Thread2,
        deviceObject);

    if (!NT_SUCCESS(status))
    {
        DbgPrint("PsCreateSystemThread() 0x%x\n", status);

        return status;
    }

    status = PsCreateSystemThread(
        &threadHandle3,
        (ACCESS_MASK) 0L,
        NULL,
        NULL,
        NULL,
        (PKSTART_ROUTINE)Thread3,
        deviceObject);

    if (!NT_SUCCESS(status))
    {
        DbgPrint("PsCreateSystemThread() 0x%x\n", status);

        return status;
    }

    return STATUS_SUCCESS;
}
